package hk.quantr.jcd;

import java.io.File;
import javax.swing.Action;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import org.netbeans.core.spi.multiview.CloseOperationState;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.netbeans.core.spi.multiview.MultiViewElementCallback;
import org.openide.awt.UndoRedo;
import org.openide.loaders.DataObject;
import org.openide.util.Lookup;
import org.openide.util.NbBundle.Messages;
import org.openide.windows.TopComponent;

@MultiViewElement.Registration(
    displayName = "#LBL_JavaClass_Disassem",
//    iconBase = "hk/quantr/jcd/javaLogo16_16.png",
    mimeType = "text/x-class",
    persistenceType = TopComponent.PERSISTENCE_NEVER,
    preferredID = "JavaClassVisual",
    position = 2000
)
@Messages("LBL_JavaClass_Disassem=Disassembler")
public final class JavaClassVisualElement extends JPanel implements MultiViewElement {
    private JavaClassDataObject obj;
    private JToolBar toolbar = new JToolBar();
    private transient MultiViewElementCallback callback;

    public JavaClassVisualElement(Lookup lkp) {
        obj = lkp.lookup(JavaClassDataObject.class);
        assert obj != null;
        initComponents();
		
		System.out.println(lkp.lookup(DataObject.class).getPrimaryFile().getPath());
		File file = new File(lkp.lookup(DataObject.class).getPrimaryFile().getPath());
		System.out.println(file.getAbsolutePath());
    }

    @Override
    public String getName() {
        return "JavaClassVisualElement";
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        textArea1 = new java.awt.TextArea();

        setLayout(new java.awt.BorderLayout());

        jScrollPane2.setViewportView(textArea1);

        add(jScrollPane2, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane2;
    private java.awt.TextArea textArea1;
    // End of variables declaration//GEN-END:variables


    @Override
    public JComponent getVisualRepresentation() {
        return this;
    }

    @Override
    public JComponent getToolbarRepresentation() {
        return toolbar;
    }

    @Override
    public Action[] getActions() {
        return new Action[0];
    }

    @Override
    public Lookup getLookup() {
        return obj.getLookup();
    }

    @Override
    public void componentOpened() {
    }

    @Override
    public void componentClosed() {
    }

    @Override
    public void componentShowing() {
    }

    @Override
    public void componentHidden() {
    }

    @Override
    public void componentActivated() {
    }

    @Override
    public void componentDeactivated() {
    }

    @Override
    public UndoRedo getUndoRedo() {
        return UndoRedo.NONE;
    }

    @Override
    public void setMultiViewCallback(MultiViewElementCallback callback) {
        this.callback = callback;
    }

    @Override
    public CloseOperationState canCloseElement() {
        return CloseOperationState.STATE_OK;
    }

}

